
##Tested with: Mini maestro 12 & Ubuntu Linux
##Install the serial port script for PERL
##sudo apt-get install libdevice-serialport-perl
##Do not forget to change the Serial settings to USB Dual Port using 
## the Pololu Maestro Control Center

## Also the minimaestro Port 0 was configured to the range [600,2400]
## Assume that communication port is /dev/ttyACM0

#!/usr/bin/perl -w
use strict;
use warnings;

use Time::HiRes qw(usleep nanosleep);
use Device::SerialPort; 


my $port = Device::SerialPort->new("/dev/ttyACM0");
$port->baudrate(9600);
$port->parity("none");
$port->handshake("none");
$port->databits(8);
$port->stopbits(1);
$port->read_char_time(0);
$port->read_const_time(1);




my $pos = 1500*4;
my $upp = $pos & 0x7F;
my $lop = $pos >> 7 & 0x7F;


my $t=0.0;
my $onePI=3.14159265;
my $twoPI=6.28318531;
my $teta;
my $sp;
my $position;
while (1){

        $teta =  0.5*$onePI*cos($t+$onePI)+0.5*$onePI;
        $sp = ($teta*1800/$onePI)+600;
        $sp = $sp*4;
        $position = sprintf("%d", $sp);

        $upp = $position & 0x7F;
        $lop = $position >> 7 & 0x7F;

        print $position; print "\t";
        print $upp; print "\t"; print $lop; print "\n";
	my $pack = pack("CCCC", 0x84, 0, $upp, $lop);
	$port->write($pack);
	##print unpack("H*", $pack) . "\n";

       # 1 millisecond == 1000 microseconds
       usleep(50000);

      $t+=0.025;
      if($t>=($twoPI-0.025)){
      $t=0.0;
      }
}

$port->close;


